classdef DMctrl<handle
    properties
        
        hDM
        Gain
        serialName
        
        
    end
    
    
    %life cycle
    methods
        function obj=DMctrl()
            obj.Gain=8191; %default gain
            obj.serialName='BAX331';
        end
        
        function delete(obj)
           
           if ishandle(obj.hDM)
           obj.deinitializeDM()
           end
       
        end
    end
    
    %User methods
    methods
        function success=initializeDM(obj) 
           emsg=[];
            try
            obj.hDM=AOcontrol.DMdriver.asdkDM(obj.serialName);
            catch emsg
                
            end
            if ~isempty(emsg)
                success=0;
            else
                
                %obj.Z2CMtx=importdata( [obj.serialName, '-Z2C.mat'] );
                %import z2c matrix moved to AOdata object.
                obj.hDM.Set('TriggerMode',1); % 0 for long pulse width, 1 for short.
                success=1;
                %Parameter setting can be added as needed
            end
            
            
        end
        
        function success=deinitializeDM(obj)
           obj.stopDM;
           delete(obj.hDM);
           obj.hDM=[];
           success=1;
        end
        
        function stopDM(obj)
            obj.hDM.Stop();
            %obj.hDM.Reset();
        end

        function sendpatterndata(obj,data)
            % send data loaded externally.
            % data: [frames,Nactuator].
            [A,B]=size(data);
            linDMdata=reshape(data',1,A*B);
            obj.hDM.SendPattern(linDMdata,0);
        end
        
        function senddata(obj,data)
            % immediately send one vector of DM data to DM.
            % data: [frames,Nactuator].
            obj.hDM.Send(data);
            
        end
        
        function resetDM(obj)
           obj.hDM.Send(zeros(97,1)); 
        end
        
        function triggeron(obj)
            obj.hDM.Set('TriggerIn',2) % 1 for triggering of rising edge. 2 for falling edge, 
                                       % PEX-292144 only support trigger on falling edge
            
        end
        
        function triggeroff(obj)
            obj.hDM.Set('TriggerIn',0) % 0 for disabled triggering
        end
        
        function synchronous(obj)
            obj.hDM.Set('SyncMode',0) % 0 for disabled triggering
        end
        function asynchronous(obj)
            obj.hDM.Set('SyncMode',1) % 0 for disabled triggering
        end       
        
    end
end