function varargout = CameraGUI(varargin)
% CAMERAGUI MATLAB code for CameraGUI.fig
%      CAMERAGUI, by itself, creates a new CAMERAGUI or raises the existing
%      singleton*.
%
%      H = CAMERAGUI returns the handle to a new CAMERAGUI or the handle to
%      the existing singleton*.
%
%      CAMERAGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in CAMERAGUI.M with the given input arguments.
%
%      CAMERAGUI('Property','Value',...) creates a new CAMERAGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before CameraGUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to CameraGUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help CameraGUI

% Last Modified by GUIDE v2.5 15-Aug-2016 10:00:55

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @CameraGUI_OpeningFcn, ...
                   'gui_OutputFcn',  @CameraGUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before CameraGUI is made visible.
function CameraGUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to CameraGUI (see VARARGIN)

% Choose default command line output for CameraGUI
handles.output = hObject;
%get AOROI ctrl handles
handles.ctrl=varargin{1};

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes CameraGUI wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = CameraGUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in cooleron.
function cooleron_Callback(hObject, eventdata, handles)
% hObject    handle to cooleron (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if handles.ctrl.hSHctrl.cooleron==0
    success=handles.ctrl.hSHctrl.turncooleron();
    if success==true
        handles.ctrl.hSHctrl.cooleron=1;
        set(handles.cooleron,'String','Turn off Cooler')
    else
        return
    end
else
    success=handles.ctrl.hSHctrl.turncooleroff();
    if success==true
        handles.ctrl.hSHctrl.cooleron=0;
        set(handles.cooleron,'String','Turn on Cooler')
    else
        return
    end
end


function coolertemp_Callback(hObject, eventdata, handles)
% hObject    handle to coolertemp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of coolertemp as text
%        str2double(get(hObject,'String')) returns contents of coolertemp as a double
temp=str2double(get(hObject,'String'));

if ~(temp<=15&&temp>=-80) %Range of allowed temperature, to be determined.
    msgbox('Temperature must fall in [-80,15]','Error')
    set(hObject,'String','15');
   
    return
else
    success=handles.ctrl.hSHctrl.setcoolertemp(temp);
    if success==1
       handles.ctrl.hSHctrl.settemp=temp;
    else
        msgbox('Temperature set unsuccessful, check error message','Error')
       set(hObject,'String','15');
    end
    
end

% --- Executes during object creation, after setting all properties.
function coolertemp_CreateFcn(hObject, eventdata, handles)
% hObject    handle to coolertemp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
%hObject.String=num2str(handles.ctrl.hSHctrl.expotime);


function expotime_Callback(hObject, eventdata, handles)
% hObject    handle to expotime (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of expotime as text
%        str2double(get(hObject,'String')) returns contents of expotime as a double
expotime=str2double(get(hObject,'String'));
handles.ctrl.hSHctrl.expotime=expotime;

% --- Executes during object creation, after setting all properties.
function expotime_CreateFcn(hObject, eventdata, handles)
% hObject    handle to expotime (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function emgain_Callback(hObject, eventdata, handles)
% hObject    handle to emgain (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of emgain as text
%        str2double(get(hObject,'String')) returns contents of emgain as a double
emgain=str2double(get(hObject,'String'));
if ~(emgain>=2&&emgain<=300)
msgbox('gain must fall in [2,300]','Error')
else
    success=handles.ctrl.hSHctrl.setemgain(emgain);
    if success==false
        set(hObject,'String','2')
    end
end


% --- Executes during object creation, after setting all properties.
function emgain_CreateFcn(hObject, eventdata, handles)
% hObject    handle to emgain (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in checktemp.
function checktemp_Callback(hObject, eventdata, handles)
% hObject    handle to checktemp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
temp=handles.ctrl.hSHctrl.checktemp();
set(handles.currenttemp,'String',temp);


% --- Executes on button press in startstream.
function startstream_Callback(hObject, eventdata, handles)
% hObject    handle to startstream (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in takeshot.
function takeshot_Callback(hObject, eventdata, handles)
% hObject    handle to takeshot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
imgdata=handles.ctrl.hSHctrl.takeSHdata;
meanval=mean(mean(imgdata));
stdvalue=std(double(imgdata));
minval=meanval-4*stdvalue(50);
maxval=meanval+4*stdvalue(50);
%[min,max]=[min(imgdata),max(imgdata)];
figure;
imshow(imgdata,[minval,maxval]);




