function im = highpassImage(subimage)
    x = fft2(subimage);
    H = createHighPassEmphasisFilter([size(subimage,1),size(subimage,2)]);
    im = ifft2(H.*x,'symmetric');
end

function H = createHighPassEmphasisFilter(outsize)
    % Defines High-Pass emphasis filter used in Reddy and Chatterji
    numRows = outsize(1);
    numCols = outsize(2);

    x = linspace(-0.5,0.5,numCols);
    y = linspace(-0.5,0.5,numRows);

    [x,y] = meshgrid(x,y);

    X = cos(pi*x).*cos(pi*y);

    H = (1-X).*(2-X);
end