% Load data to DM and save movie, with different pattern added to DM in
% each frame.
% Presetings: set the image ROI and saveed channel 

clear ZVector corDMcommand gradient intensity;
%addpath('D:\Rui\20161105 sensorless wavefront sensing');
hAOROIctrl.hDMctrl.triggeron;
hAOROIctrl.hDMctrl.asynchronous;
load('BAX331-Z2C.mat');
imgsize_x = 512;
imgsize_y = 512;
settletimeline = 30;%romove the pixels that might be affected by the settle time of DM
zernikemodeN = 60;
Zstart = 4;
Zend = zernikemodeN;
z2c = Z2C;
clear Z2C
Z2C=z2c(1:zernikemodeN,:);
Ncycle = 30;%30
d=0.02; %0.025
Nrep = 11; % number of times to repeat measurment cycle, for averaging purposes.
Zdescent=0.01; %step factor 0.01
zernike_opt_history=zeros(Ncycle,zernikemodeN);
Intensity_history_est=zeros(Ncycle,1);
Intensity_history_temporal=[];
Gradient_history=zeros(Ncycle,zernikemodeN);
% zernike_current=zeros(1,zernikemodeN);
indexzcommand = zeros(1,zernikemodeN);
indexzcommand(Zstart:Zend) = 1;
% Build list of zernike vector to be loaded, format: [0;+d1;-d1;+d2;-d2;....]
i=1;
j=1;
Vzero=zeros(1,zernikemodeN);
Zdelta =[];
while i<=length(indexzcommand)
   if indexzcommand(i)==1
       Vzero(i)=1;
       Zdelta(j,:)=d*Vzero;
       Zdelta(j+1,:)=(-1)*d*Vzero;
       Vzero(i)=0;
       j=j+2;
   end
   i=i+1;
end
Zdelta=[Vzero;Zdelta];

Framepercyc=size(Zdelta,1); %24 Nmode*2
ZVector = zeros(size(Zdelta));

h = waitbar(0,'System aberration optimization...');
for C = 1:Ncycle %interitive cycle times
    
    ZVector= Zdelta+ zernike_current;  
    
    
    imgname = sprintf('%s%d','cycle',C);
    assert(strcmpi(hSI.acqState,'idle'));       
    hSI.hScan2D.logFilePath = 'C:\Users\dklab\Desktop\SI2018bR1_2018-12-19_4a9264c4fc';      
    hSI.hScan2D.logFileStem = imgname ;     % set the base file name for the Tiff file
    hSI.hScan2D.logFileCounter = 1;         % set the current Tiff file number
    hSI.hChannels.loggingEnable = true;     % enable logging
    hSI.hStackManager.framesPerSlice = Framepercyc*Nrep;   % set number of frames to capture in one Grab
     
    DMcommand = (ZVector*Z2C);
    hAOROIctrl.hDMctrl.sendpatterndata(DMcommand);
    hSI.startGrab();                   
   
    while ~strcmpi(hSI.acqState,'idle')
         pause(0.5)
    end   
    hSI.startFocus()
    hAOROIctrl.hDMctrl.stopDM;    
    hSI.abort()
      
    filename=sprintf('%s%d%s','cycle',C,'_00001.tif');
    nFrames=size(ZVector,1)*Nrep;
    [img_, framenum] = imreadtifseries(filename,nFrames);
%     tic,
%     t = tiffMap(filename);
%     channels = [1];
%     img = t(channels,:); %This returns all frames in channels 1
%     toc
    
    img = img_(settletimeline+1:imgsize_y,:,:);

    intensity_=squeeze(mean(mean(img)));
    intensity_=reshape(intensity_,[size(ZVector,1),Nrep]);
    intensity = mean(intensity_(:,2:Nrep),2)';
    
    
    gradient=(intensity(2:2:end-1)-intensity(3:2:end))/(2*d);
    Intensity_history_est(C) = intensity(1);
    Gradient_history (C,Zstart:Zend) = gradient;
    norm = sqrt(sum(gradient.^2));
    gradient_normal=gradient/norm*Zdescent;
    
    
    zernike_current(Zstart:Zend) = zernike_current(Zstart:Zend) + gradient_normal;
    zernike_opt_history(C,:) = zernike_current;
    
%     hAOROIctrl.hDMctrl.senddata(zernike_opt_history(20,:)*Z2C);
%     hAOROIctrl.hDMctrl.senddata(zeros(1,30)*Z2C);
    figure;
    subplot(3,1,1);plot(zernike_opt_history(:,Zstart:Zend));
    subplot(3,1,3);bar(zernike_current);
    subplot(3,1,2);plot(zernike_opt_history(:,4:14));
%     
%     figure;
%     subplot(3,1,1);plot(Gradient_history(:,Zstart:Zend));
%     subplot(3,1,2);plot(Gradient_history(:,4:14));
%     subplot(3,1,3);bar(gradient);
    
    figure,plot(Intensity_history_est);
    figure,plot(intensity_);hold on, plot(intensity','k'); hold off
    
    delete(filename)
    
    waitbar(C/Ncycle);
end  
hAOROIctrl.hDMctrl.triggeroff;
close(h);
%% result test
figure,plot(zernike_opt_history(:,4:Zend));
figure;bar(zernike_current);
% zernike_current_average = mean(zernike_opt_history(7:10,:));
% figure;bar(zernike_current_average);
DMcommand_sys_aber_cor_930 = zernike_current*Z2C;
DMcommand_sys_aber_cor_1030 = zernike_current*Z2C;
DMcommand_sys_aber_cor_1250 = zernike_current*Z2C;

hAOROIctrl.hDMctrl.senddata(DMcommand_sys_aber_cor_1030);
hAOROIctrl.hDMctrl.senddata(DMcommand_sys_aber_cor_930);
hAOROIctrl.hDMctrl.senddata(DMcommand_sys_aber_cor_1250);

Czero=zeros(1,97);
hAOROIctrl.hDMctrl.senddata(Czero);


DMcommand_sys_aber_cor_1070_zero=zernike_zero_offset*Z2C;
hAOROIctrl.hDMctrl.senddata(DMcommand_sys_aber_cor_1070_zero);
% try other order system aberration correction
zernike_test=zernike_current_average;
zernike_test(26:60)=0;
DMcommand_sys_aber_cor_1070_test=zernike_test*Z2C;
hAOROIctrl.hDMctrl.senddata(DMcommand_sys_aber_cor_930_test);


%% draw wavefront pattern

% load('BAX331-Z2C.mat')
% load('Calibration_10052022.mat')
% load('C:\Users\dklab\Desktop\SI2018bR1_2018-12-19_4a9264c4fc\calibration-20221002212344\shstruct.dai.mat')

lambda=1070e-9;
deltabasis_x = zeros(zernikemodeN,shstruct.nspots);
deltabasis_y = zeros(zernikemodeN,shstruct.nspots);
for i=1:zernikemodeN
    img = DM_calibration_shdata(:,:,i);
    aberrated = shwfs_get_centres_nodraw(img, shstruct, shstruct.centroid);
    sdeltas = aberrated - shstruct.ord_centres;
    deltabasis_x(i,:) = (sdeltas(:,1))';
    deltabasis_y(i,:) = (sdeltas(:,2))';    
end

figure;

    zernike_current ;
    aberration_by_DM_x = zernike_current*deltabasis_x;
    aberration_by_DM_y = zernike_current*deltabasis_y;
    aberration_by_DM(:,1) = aberration_by_DM_x';
    aberration_by_DM(:,2) = aberration_by_DM_y';

    flen = shstruct.flength;
    ps = shstruct.camera_pixsize;
    t = ps*aberration_by_DM;
    s = t(:);
    zrad = (1/flen)*(shstruct.dai_pE1*s);
    se = flen*(shstruct.dai_E1)*zrad;
    er = s - se;
    zhatrad = ((2*pi)/(lambda))*zrad;

    zstruct = shstruct.dai_zstruct;
    dd = linspace(-1, 1, 1000);
    [xx, yy] =  meshgrid(dd, dd);
    zstruct = zernike_cache(zstruct, xx, yy);

    zcs = [0; zhatrad];
    sel = 1:size(zhatrad, 1);

      zernike_imagesc(zstruct, zcs);
      caxis([-1.5,1])